﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.Drawing.Printing
Imports PdfSharp.Pdf

Public Class Form1

    Private dyn_wells As ThinkGeo.MapSuite.DesktopEdition.LayerOverlay
    Private wellspot_size As Integer = 4
    Private gridoverlay As ThinkGeo.MapSuite.DesktopEdition.LayerOverlay
    Public WithEvents gridlayer1 As SeamlessGrid

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        add_wells()

    End Sub

    Private Sub add_wells()
        dyn_wells = New ThinkGeo.MapSuite.DesktopEdition.LayerOverlay

        Dim inMemoryLayer As New InMemoryFeatureLayer()
        inMemoryLayer.Open()
        inMemoryLayer.Columns.Add(New FeatureSourceColumn("Status"))
        inMemoryLayer.Columns.Add(New FeatureSourceColumn("Wellname"))
        inMemoryLayer.Columns.Add(New FeatureSourceColumn("UWI"))
        inMemoryLayer.Columns.Add(New FeatureSourceColumn("WellID"))
        inMemoryLayer.Close()

        For r = 0 To 50
            Dim x_rnd As Single = Rnd()
            Dim y_rnd As Single = Rnd()
            Dim status_rnd As Integer = Rnd() * 4
            Dim p As New PointShape(x_rnd, y_rnd)

            Dim cv As New Dictionary(Of String, String)
            cv.Add("Status", status_rnd)
            Debug.Print(status_rnd.ToString)
            cv.Add("Wellname", "Point " + r.ToString())
            cv.Add("WellID", r)
            p.Tag = "Point " + r.ToString()
            Dim ppoint As New Feature(p, cv)
            ppoint.Tag = p.Tag
            inMemoryLayer.InternalFeatures.Add(r, ppoint)
        Next

        Dim valuestyle As New ValueStyle()
        valuestyle.ColumnName = "Status"
        valuestyle.ValueItems.Add(New ValueItem("0", New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.FromArgb(255, 128, 128, 128)), wellspot_size)))
        valuestyle.ValueItems.Add(New ValueItem("1", New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.FromArgb(255, 0, 0, 0)), wellspot_size)))
        valuestyle.ValueItems.Add(New ValueItem("2", New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.FromArgb(255, 255, 0, 0)), wellspot_size)))
        valuestyle.ValueItems.Add(New ValueItem("3", New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.FromArgb(255, 0, 0, 255)), wellspot_size)))
        valuestyle.ValueItems.Add(New ValueItem("4", New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.FromArgb(255, 0, 255, 0)), wellspot_size)))

        Dim welltextstyle As New WellLabelTextStyle.WellLabelTextStyle
        inMemoryLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(welltextstyle)
        inMemoryLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valuestyle)

        inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        dyn_wells.Layers.Add("WellsLayer", inMemoryLayer)
        WinformsMap1.Overlays.Add(dyn_wells)
        inMemoryLayer.Open()
        WinformsMap1.CurrentExtent = inMemoryLayer.GetBoundingBox
        inMemoryLayer.Close()
        WinformsMap1.Refresh()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        WinformsMap1.ZoomOut(50)
        WinformsMap1.Refresh()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        WinformsMap1.ZoomIn(50)
        WinformsMap1.Refresh()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'do the printing
        Dim pgeo As New PrinterGeoCanvas()
        Dim Dialog1 As New PrintDialog()
        Dim labelsInLayers As New Collection(Of SimpleCandidate)()
        Dim document As New PrintDocument()

        Dialog1.Document = document
        Dialog1.AllowSomePages = True
        Dim results As DialogResult = Dialog1.ShowDialog()
        document.DefaultPageSettings.Margins = New Margins(0, 0, 0, 0)
        document.OriginAtMargins = False
        Debug.Print("width = " + document.DefaultPageSettings.Bounds.Width.ToString())
        pgeo.DrawingArea = New Rectangle(0, 0, document.DefaultPageSettings.PrintableArea.Width, document.DefaultPageSettings.PrintableArea.Height)
        Dim cext As RectangleShape = WinformsMap1.CurrentExtent
        pgeo.BeginDrawing(document, cext, GeographyUnit.Meter)
        For Each layeroverlay As LayerOverlay In WinformsMap1.Overlays
            For Each layer As Layer In layeroverlay.Layers
                layer.Open()
                layer.Draw(pgeo, labelsInLayers)
                layer.Close()
                pgeo.Flush()
            Next
        Next

        If Not gridlayer1 Is Nothing Then
            gridlayer1.Draw(pgeo, labelsInLayers)
        End If

        If results = DialogResult.OK Then
            pgeo.EndDrawing()
        End If
    End Sub

    Private Sub Form1_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        WinformsMap1.Refresh()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Try
            WinformsMap1.Overlays.Remove(gridoverlay)
        Catch ex As Exception

        End Try
        gridlayer1 = New SeamlessGrid(Application.StartupPath + "\Grid_test.txt")
        gridoverlay = New LayerOverlay()
        gridoverlay.Name = "Grid1"
      
        gridoverlay.Layers.Add("Grid1", gridlayer1)
        WinformsMap1.Overlays.Add(gridoverlay)
        WinformsMap1.Refresh(gridoverlay)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim document As New PdfDocument()
        Dim page As PdfPage = document.AddPage()
        'If rdlOptions.SelectedItem.Text = "Landscape" Then
        'page.Orientation = PageOrientation.Landscape
        'End If
        Dim pdfGeoCanvas As New PdfGeoCanvas()

        ' This allows you to control the area in which you want the
        ' map to draw in. Leaving this commented out uses the whole page
        'pdfGeoCanvas.DrawingArea = new Rectangle(200, 50, 400, 400);

        Dim labelsInLayers As New Collection(Of SimpleCandidate)()
        For Each overlay As Overlay In WinformsMap1.Overlays
            Dim currentOverlay As LayerOverlay = TryCast(overlay, LayerOverlay)
            If currentOverlay IsNot Nothing Then
                For Each layer As Layer In currentOverlay.Layers
                    Dim printExtent As RectangleShape = ExtentHelper.GetDrawingExtent(WinformsMap1.CurrentExtent, CSng(WinformsMap1.Width), CSng(WinformsMap1.Height))
                    pdfGeoCanvas.BeginDrawing(page, printExtent, GeographyUnit.Meter)
                    layer.Open()
                    layer.Draw(pdfGeoCanvas, labelsInLayers)
                    layer.Close()
                    pdfGeoCanvas.EndDrawing()
                Next
            End If
        Next

        SaveFileDialog1.Filter = "*.pdf|*.pdf"
        SaveFileDialog1.Title = "Select location to save PDF file"
        Dim r As DialogResult = SaveFileDialog1.ShowDialog()
        If r = Windows.Forms.DialogResult.OK Then
            Dim filename As String = SaveFileDialog1.FileName
            document.Save(filename)
            Process.Start(filename)
        End If
    End Sub
End Class
